from __future__ import annotations

import struct


def parse_raw(data: bytes) -> str:
    revision = data[0]
    count_sub_auths = data[1]
    # clear first two bytes for 64-bit decoding
    authority_raw = b"\x00\x00" + data[2:8]
    (authority,) = struct.unpack(">Q", authority_raw)
    assert len(data) == 8 + 4 * count_sub_auths
    sub_auths = struct.unpack_from(f"< {count_sub_auths}I", data, 8)
    return f"S-{revision}-{authority}" + "".join(f"-{auth}" for auth in sub_auths)
